/*
	NGlobal.h
 
	NasuTen
	Copyright (C) 1996 Takeshi Yoneki, OSTRACISM CO.
 
	Make : 1996.02.12	1.0			Takeshi Yoneki
*/

#ifndef _NGLOBAL_H_
#define _NGLOBAL_H_

#include "csystem.h"

/* XNvgΉ̃fXNv^^Cv */
/* AvP[V */
enum {
    keywordNew = 'New ',
    classMP3File = 'MP3F',
    classApplication = 'null'
};

typedef unsigned char BYTE;

#include "nmenu.h"
#include "ntag.h"
#include "npref.h"
#include "nview.h"
#include "mfile.h"
#include "medit.h"
#include "mid3.h"
#include "mwindow.h"

class NMain : public TAppleObject {
public:
	TString m_applName;
	CUPP_AEEventHandler m_uppAEOpenAppl;
	CUPP_AEEventHandler m_uppAEOpenDosc;
	CUPP_AEEventHandler m_uppAEPrintDocs;
	CUPP_AEEventHandler m_uppAEQuitAppl;
	long m_startTickCount;
	Boolean m_quitAfterJob;
	NMain();
	~NMain();
	void Initial();
	TWindow *WhichWindow(WindowPtr win);
	void OnKey();
	void OnMouseDown();
	void OnActivate(WindowRef win, Boolean act);
	void OnOSEvt();
	void OnUpdate();
	void MainLoop();
	void OnTask();
	void doFinderInfo();
	void OnHighLevelEvent();
	/* TAppleObject̉z֐ */
	virtual CFStringRef GetObjectName() {
		return m_applName;
	}
	virtual DescType GetObjectType() {
		return classApplication;
	}
	virtual TAppleObject *GetContainedObject(DescType desiredClass, DescType keyForm, const AEDesc *keyData);
	virtual TAppleObject *GetObjectProperty(DescType desiredClass, DescType keyForm, const AEDesc *keyData);
	virtual long CountContainedObjects(DescType desiredClass);
	virtual OSErr OnAppleEvent(AEEventID eventID, DescType desiredClass, const AppleEvent *aev, TAEResult *result);
	virtual OSErr OnAdhocForContainer(TToken *token, AEEventID eventID, const AppleEvent *aev, TAEResult *result);
};

/*
	l[O[
 
	NXF
		Cxxxxx		Class Library
		Nxxxxx		Application Native Class
		Mxxxxx		Application Menu Command Class
 
	oF
		om_Ŏn܂B͂قTen Tool Class Libraryňт
		HĂBATSystem͗OB
		MFC̕@̐^BMS΂肶ȂB
 
	\bhF
		\bh͑啶Ŏn܂AP؂͑啶؂ւB
*/

#ifdef _MAIN_
#define	EXTERN
#else
#define EXTERN	extern
#endif

#define	FINGER_CURSOR			128
#define	PECK_FINGER_CURSOR		129
#define	SPIN_WATCH_CURSOR		130
#define	SPLIT_CURSOR			138
#define	SPIN_CIRCLE_CURSOR		140
#define	WHITE_ARROW_CURSOR		148
#define	BOOK_PAGE_CURSOR		150

#define	ERROR_DLG				128
#define	ERROR_MSG_DITEM			2

#define	STRNUM_ID_MISC			128

#define	STRNUM_ID_ENCASIS		129
#define	STRNUM_SHIFTJIS			1
#define	STRNUM_MACROMAN			2
#define	STRNUM_ASIS				3

#define	STRNUM_ID_FDTYPE		130

#define STRNUM_ID_GENRE			300


/* RANX */
EXTERN NMenu *theMenu;
EXTERN NPref *thePref;

/* j[R}hNX */
EXTERN MApple *theMApple;
EXTERN MFile *theMFile;
EXTERN MEdit *theMEdit;
EXTERN MID3 *theMID3;
EXTERN MWindow *theMWindow;

EXTERN MVersion *theMVersion;
EXTERN MLoadEnc *theMLoadEnc;
EXTERN MSaveEnc *theMSaveEnc;
EXTERN MGenre *theMGenre;
EXTERN MFont *theMFont;
EXTERN MSize *theMSize;

EXTERN MVersion *theMDVersion;
EXTERN MLoadEnc *theMDLoadEnc;
EXTERN MSaveEnc *theMDSaveEnc;
EXTERN MGenre *theMDGenre;

EXTERN NGlobalData *theGlobalData;
EXTERN CEvent *theEvent;
EXTERN NMain *theMain;

#endif
