/*
	TScript.h
	XNvgNX
 
	Ten Tool Class Library
	Copyright (C) 2000 Takeshi Yoneki, OSTRACISM CO.
 
	Make : 2000.03.24	1.0			Takeshi Yoneki
*/

#ifndef	_CSCRIPT_H_
#define	_CSCRIPT_H_

class TScript;
class TMainObject;

class TScript {
public:
	TAppleObject *m_main;
	Boolean m_logAppleEvent;
	CUPP_AEEventHandler m_uppOnWildCard;
	CUPP_OSLAccessor m_uppObjFromWildCard;
	CUPP_OSLAccessor m_uppPropFromWildCard;
	CUPP_OSLCompare m_uppCompare;
	CUPP_OSLCount m_uppCount;
	TScript(TAppleObject *main, AEEventClass applClassID);
	OSErr OnWildCard(const AppleEvent *aev, AppleEvent *reply, long refCon);
	OSErr Accessor_ObjFromWildCard(DescType desiredClass, const AEDesc *container, DescType containerClass, DescType keyForm, const AEDesc *keyData, AEDesc *value, long accessorRefcon);
	OSErr Accessor_PropFromWildCard(DescType desiredClass, const AEDesc *container, DescType containerClass, DescType keyForm, const AEDesc *keyData, AEDesc *value, long accessorRefcon);
	OSErr Count_WildCard(DescType desiredClass, DescType containerClass, const AEDesc *container, long *result);
	OSErr Compare_WildCard(DescType oper, const AEDesc *desc1, const AEDesc *desc2, Boolean *result);
	void InstallObject(DescType desiredClass, DescType containerType);
	void InstallProperty(DescType containerType);
};

#endif
