/*
	TSystem.h
	VXeNX
	Ten Tool Class Library͍ŒtheSystemnewĂȂƓȂ
 
	Ten Tool Class Library
	Copyright (C) 1996 Takeshi Yoneki, OSTRACISM CO.
 
	Make : 1996.02.12	1.0			Takeshi Yoneki
*/

#ifndef _CSYSTEM_H_
#define _CSYSTEM_H_

#ifdef __MWERKS__
#define	htons(a)	(a)
#define	ntohs(a)	(a)
#endif

#include "cclass.h"

/* XNvgΉ̃fXNv^^Cv */
/* NXCu */
enum {
    classAppleObject = 'AObj',
    classAppleObjectArray = 'AAry',

    classString = 'Str ',
    classUniString = 'UStr',
    classCFString = 'CFSt',
    classDirectory = 'Dir ',
    classFSSpec = 'FSSp',
    classInteger = 'Int ',
    classBoolean = 'Bool',

    methodAdd = 'Add ',
    methodAddLine = 'AdLn',
    methodInsert = 'Inst',
    methodInsertLine = 'InLn',
    methodSave = 'Save',

    methodMakeWindow = 'MkWi',
    methodMakeLine = 'MkLn',
    keywordOn = 'On  ',

    keywordAsFile = 'AsFl',
    keywordAtFolder = 'AtFd',

    classTextEditor = 'TEdt',
    classLine = 'Line',
    propLineCount = 'LinC',
    propModified = 'Modf',
    propPosted = 'Post',

    classFolder = 'Fold',
    classFile = cFile,

    classSystem = 'null'
};

/**/
#include "design.h"
#include "ccmn.h"
#include "cupp.h"
#include "cbase.h"
#include "cftools.h"
#include "cstring.h"
#include "cdraw.h"
#include "ccontrol.h"
#include "cprocess.h"
#include "cosa.h"
#include "cfile.h"
#include "cmenu.h"
#include "cdrag.h"
#include "cwindow.h"
#include "cdialog.h"
#include "ceditor.h"
#include "csocket.h"
#include "cscript.h"
#include "ckanji.h"

/*
	TSystem
	AvP[VɂP݂ȂTen Tool Class Library͓삵ȂB
	Ă邯ǂˁB
*/
class TSystem {
public:
	//	TWorkDir applVRefNum;
	//	TWorkDir sysPrefVRefNum;
	long systemVersion;
	Boolean hasColorQD;
	TDirectory sysDirectory;
	TDirectory applDirectory;
	TDirectory sysPrefDirectory;
	Boolean has32ColorQD;
	Boolean hasAppleEvents;
	Boolean hasTSMTE;
	long tsmteVersion;
	Boolean hasAppleScript;
	Boolean hasDragMgr;
	Boolean hasBaloonHelp;
	Boolean hasThreadMgr;
	Boolean hasAppearance;
	int appearanceVersion;
	Boolean hasNavigation;
	Boolean hasTempMemory;
	Boolean hasHFSPlus;
	Boolean hasTextEncodingConverter;
	TStringList m_friendAppl;
	char m_charByteData[256];
	TUnicodeTextEncodingInfo m_encInfo;
	ComponentInstance m_scriptingComponent;
	CUPP_GrowZone m_uppGrowZoneProcInfo;
	TPixPat *whitePixPat;
	TPixPat *grayPixPat;
	TPixPat *deepPixPat;
	TPixPat *blackPixPat;
	Boolean m_useNavigation;
	UInt32 m_safetyMemorySize;
	int carbonVersion;
	TSystem(int masters, long stack, long configFlags = 0);
#define	SYSTEM_CONFIG_FLAG_NOT_USE_NAV			1

	~TSystem();
	void InitToolbox(int masters, long stack);
	TRgn GetDesktopRgn();
	TRect GetDesktopRect();
	Boolean IsFriend(OSType creator);
	void MakeCharSize(TWindow *port);
	int GetCharSize(unsigned char ch) {
		return m_charByteData[ch];
	}
	int GetMainDepth();
	Boolean SystemEdit(short editCmd) {
		return FALSE;
	}
	short OpenDeskAcc(ConstStr255Param deskAccName) {
		return 0;
	}
	void SystemClick(const EventRecord *ev, WindowPtr win) {
	}
	Boolean TSMMenuSelect(long menuResult) {
		return FALSE;
	}
};

void FatalErrorDlg(int errorNumber);

#ifdef _MAIN_
#define	T_EXTERN
#else
#define T_EXTERN	extern
#endif

T_EXTERN TSystem *theSystem;
T_EXTERN TCursorList *theCursor;
T_EXTERN TDebug *theDebug;
T_EXTERN TWindowArray *theWindowArray;

#ifdef CONFIG_USE_CEDITOR
T_EXTERN TEditorUndo *theUndo;
#endif

#endif
