/*
	MEdit.h
	ҏWj[R}hNX
 
	NasuTen
	Copyright (C) 1996 Takeshi Yoneki, OSTRACISM CO.
 
	Make : 1996.03.03	1.0			Takeshi Yoneki
*/

#ifndef _MEDIT_H_
#define _MEDIT_H_

#define	UNDO_ITEM						1
#define	CUT_ITEM						3
#define	COPY_ITEM						4
#define	PASTE_ITEM						5
#define	CLEAR_ITEM						6

#define COPY_TITLE2FILE_ITEM			8
#define COPY_FILE2TITLE_ITEM			9
#define COPY_PARENT2ALBUM_ITEM			10
#define COPY_GRANPA2ARTIST_ITEM			11
#define AUTO_TRACK_ITEM					13
#define TRACK_FILE_ITEM					14
#define TRACK_TITLE_ITEM				15

#define UNDO_CMD_NON					0
#define DIFF_UNDO_REDO					100
#define UNDO_CMD_EDIT					1
#define UNDO_CMD_EDIT_ALL				2
#define UNDO_CMD_VERSION				3
#define UNDO_CMD_LOADENC				4
#define UNDO_CMD_SAVEENC				5
#define UNDO_CMD_GENRE					6
#define UNDO_CMD_AUTOTRACK				7
#define UNDO_CMD_TITLE2FILE				8
#define UNDO_CMD_FILE2TITLE				9
#define UNDO_CMD_PARENT2ALBUM			10
#define UNDO_CMD_GRANPA2ARTIST			11
#define UNDO_CMD_TRACK_FILE				12
#define UNDO_CMD_TRACK_TITLE			13
#define UNDO_CMD_TITLE2FILE_ALL			14
#define UNDO_CMD_FILE2TITLE_ALL			15
#define UNDO_CMD_PARENT2ALBUM_ALL		16
#define UNDO_CMD_GRANPA2ARTIST_ALL		17
#define UNDO_CMD_TRACK_FILE_ALL			18
#define UNDO_CMD_TRACK_TITLE_ALL		19
#define UNDO_CMD_TYPING					20

/*
#define REDO_CMD_EDIT				(UNDO_CMD_EDIT + DIFF_UNDO_REDO)
#define REDO_CMD_EDIT_ALL			(UNDO_CMD_EDIT_ALL + DIFF_UNDO_REDO)
#define REDO_CMD_VERSION			(UNDO_CMD_VERSION + DIFF_UNDO_REDO)
#define REDO_CMD_LOADENC			(UNDO_CMD_LOADENC + DIFF_UNDO_REDO)
#define REDO_CMD_SAVEENC			(UNDO_CMD_SAVEENC + DIFF_UNDO_REDO)
*/

class NTagUndo : public TArrayBase {
public:
	NView *m_view;
	int m_undoCommand;
	NTag *operator [](int n) {
		return (NTag *)GetNth(n);
	}
	NTagUndo();
	void SetUndoNon();
	void SetOneUndoTag(NView *view, int cmd, NTag *tag);
	void SetAllUndoTags(NView *view, int cmd, NTagList *tagList);
	void OnUndo();
};

class MEdit : public TMenuCommandBase {
public:
	TString m_undoStr;
	TString m_redoStr;

	TString m_title2fileStr;
	TString m_title2fileAllStr;
	TString m_file2titleStr;
	TString m_file2titleAllStr;
	TString m_parent2albumStr;
	TString m_parent2albumAllStr;
	TString m_granpa2artistStr;
	TString m_granpa2artistAllStr;
	TString m_trackFileStr;
	TString m_trackFileAllStr;
	TString m_trackTitleStr;
	TString m_trackTitleAllStr;

	char m_enable[32];
	NTagUndo m_undoTags;
	MEdit();
	void FixMenu();
	void Command(short item);
};

#endif
