/*
	MFile.h
	Abvj[R}hNX
	t@Cj[R}hNX
 
	Copyright (C) 2000 Takeshi Yoneki, OSTRACISM CO.
 
	Make : 2000.02.27	1.0			Takeshi Yoneki
*/

#ifndef	_MFILE_H_
#define	_MFILE_H_

#define	ABOUT_ITEM				1

#define	NEW_ITEM				1
#define	OPEN_ITEM				2
#define	ADD_ITEM				3
#define	CLOSE_ITEM				4
#define	SAVE_ITEM				6
#define EXPORTTSV_ITEM			7
#define IMPORTTSV_ITEM			8
#define	PREF_ITEM				10
#define	QUIT_ITEM				12

class MApple : public TMenuCommandBase {
public:
	MApple();
	void FixMenu();
	void Command(short item);
};

class MFile : public TMenuCommandBase {
public:
	Boolean m_quit;
	char m_enable[32];
	TStringList m_fdTypeList;
	TString m_openStr;
	TString m_importTSVStr;
	TString m_exportTSVStr;
	MFile();
	void FixMenu();
	void Command(short item);
	Boolean FileFilter(TUniString name, OSType fdType);
	Boolean OpenFileFilter(NTagList *tagList, TFilePath filePath, OSType fdType);
	NView *OpenFiles(TStandardFileReplyList *fileList);
	NView *AddFiles(NView *view, TStandardFileReplyList *fileList);
	NView *OnNew();
	NView *OnOpen();
	NView *OnAdd(NView *view);
	void OnSave(NView *view);
	Boolean OnImportTSV(NView *view);
	Boolean OnExportTSV(NView *view);
	void OnPref();
	void OnClose(NView *view);
	void OnQuit(const AppleEvent *aev = NULL);
	Boolean IsQuit() {
		return m_quit;
	}
};

#endif
