/*
	MFile.h
	Abvj[R}hNX
	t@Cj[R}hNX
 
	Copyright (C) 2000 Takeshi Yoneki, OSTRACISM CO.
 
	Make : 2000.02.27	1.0			Takeshi Yoneki
*/

#ifndef	_MID3_H_
#define	_MID3_H_

#define	LOAD_ENC_ITEM				1
#define	SAVE_ENC_ITEM				2
#define	GENRE_ITEM					3
#define	GENRE_SETUP_ITEM			4
#define	VERSION_ITEM				5
#define	EDIT_ITEM					7
#define	EDIT_ALL_ITEM				8
#define	FONT_ITEM					10
#define	SIZE_ITEM					11
//#define	AUTO_TRACK_ITEM				9

#define	AS_IS_ITEM					1
#define	LATIN1_ITEM					2
#define	UTF16_ITEM					3

#define	VERSION_1_0_ITEM			1
#define	VERSION_1_1_ITEM			2
#define	VERSION_2_2_ITEM			3
#define	VERSION_2_3_ITEM			4
#define	VERSION_2_4_ITEM			5

class MID3 : public TMenuCommandBase {
public:
	char m_enable[32];
	TString m_allFilesStr;
	MID3();
	void FixMenu();
	void Command(short item);
	void OnGenreSetup();
	void OnEdit(NTagList *tagList, NTag *tag);
};

class MVersion : public TMenuCommandBase {
public:
	TMenu *m_dlgMenu;
	char m_enable[32];
	MVersion();
	void FixMenu();
	void FixMenuForDialog();
	void Command(short item);
	void OnVersion(short item, NTag *tag);
};

class MLoadEnc : public TMenuCommandBase {
public:
	char m_enable[32];
	MLoadEnc();
	void FixMenu();
	void FixMenuForDialog(NTag *tag, Boolean all);
	void Command(short item);
	void OnLoadEnc(short item, NTag *tag);
};

class MSaveEnc : public TMenuCommandBase {
public:
	char m_enable[32];
	MSaveEnc();
	void FixMenu();
	void FixMenuForDialog(NTag *tag);
	void Command(short item);
	void OnSaveEnc(short item, NTag *tag);
};

class NGenreRec : public TBase {
public:
	int m_number;
	TString m_name;
	NGenreRec *GetNext() {
		return (NGenreRec *)TBase::GetNext();
	}
};

class NGenreRecList : public TListBase {
public:
	NGenreRec *GetTop() {
		return (NGenreRec *)TListBase::GetTop();
	}
};

class MGenre : public TMenuCommandBase {
public:
	NGenreRecList m_genres;
	NGenreRec **m_genreMenuItems;
	MGenre();
	void FixMenu();
	void FixMenuForDialog(NTag *tag);
	void Command(short item);
	void OnGenre(short item, NTag *tag);
	void AttachGenreMenu();
	int GenreToMenuItemNumber(int genre);
	int MenuItemNumberToGenre(int itemNo);
	TString GetGenreName(int genre);
};

/*
	MFont
*/
class MFont : public TMenuCommandBase {
public:
	MFont();
	void FixMenu();
	void Command(short item);
};

/*
	MSize
*/
class MSize : public TMenuCommandBase {
public:
	MSize();
	void FixMenu();
	void Command(short item);
	short OtherFontSizeDlg(short oldSize);
};

#endif
